// FILENAME:	TDM_Conglomrate.cs
//        11/11/00
// AUTHORS:  	][)ull Dull@WolfsRangers.com
//------------------------------------------------------------------------------

$missionName = "TDM_Conglomerate";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
$server::TeamDamage = true;

$server::AllowDeathmatch = true;
$server::AllowTeamPlay = true;	

$server::AllowTeamRed = true;
$server::AllowTeamBlue = true;
$server::AllowTeamYellow = false;
$server::AllowTeamPurple = false;

$server::disableTeamRed = false;
$server::disableTeamBlue = false;
$server::disableTeamYellow = true;
$server::disableTeamPurple = true;
}

function onMissionStart()
{
if($me::enableMissionEditor != true) SwitchDoors();
}

function onMissionLoad()
{
log(0, "Load Mission:");

cdAudioCycle("Purge", "Terror", "Watching"); 

$SDoor = getObjectId("MissionGroup/Portals-etc/SouthDoor");
$NDoor1 = getObjectId("MissionGroup/Portals-etc/NorthDoor1");
$NDoor2 = getObjectId("MissionGroup/Portals-etc/NorthDoor2");
$WDoor = getObjectId("MissionGroup/Portals-etc/WestDoor");
$EDoor1 = getObjectId("MissionGroup/Portals-etc/EastDoor1");
$EDoor2 = getObjectId("MissionGroup/Portals-etc/EastDoor2");

$openDoors = false; // At next cycle Admin can open all doors with "yes", close all with "no", or random 2 closed with anything else

if($server::teamPlay == true) %type = "<tIDMULT_TDM_GAMETYPE>";
else %type = "<tIDMULT_DM_GAMETYPE>";

%rules = 
      %type   @        
      "<tIDMULT_TDM_MAPNAME>"    @ 
      $missionName               @
   "\n\n<F2>OBJECTIVES:\n"        @
 "<F0>1) Locate and destroy enemy vehicles.\n\n"           @
 "<F0>2) Aviod getting killed.\n\n"                        @
 "<F0>3) Radar is disabled for <F6>vehicles ONLY<F0>.\n\n" @
 "<tIDMULT_TDM_SCORING_1>"  @
 "<tIDMULT_TDM_SCORING_2>"  @
 $killPoints                @
 "<tIDMULT_TDM_SCORING_3>"  @
 "<tIDMULT_TDM_SCORING_4>"  @
 $deathPoints               @
 "<tIDMULT_TDM_SCORING_5>"  @
   "<F2>Notes:\n" @
     "<F0>The building complex has multiple levels, sniping is possible. " @
   "There is only <f5>one<f0> heal pad and <f5>one<f0> reload pad, both " @
   "in the center of the complex, on the ground floor. There are also " @
   "two teleporters to the upper levels from that room, so it may be "@
   "strategic to guard it... the building has entrances on each side "@
   "(North, South, East, and West) with doors. The doors are randomly opened " @
   "every 30 seconds to 5 minutes, so the situation is always changing. " @
   "If a door is closed it will <F5>NOT<F0> open just by walking up to it. " @
   "That is NOT a bug. You either have to wait or go around.\n   Enjoy the game." @
   "\n\nSend Comments about the mission to <F2>Dull@WolfsRangers.com<F0>\n\n";

   setGameInfo(%rules);    
}

function onMissionEnd()
{
flushConsoleScheduler();
function SwitchDoors() { } // Stop the cycling after the mission is over
log(0, "End Mission:");
}



function SwitchDoors() // Switch which doors are closed every minute
{
%a = randomInt(1,2);
say( 0, 74, "", "sfx_thunder"@%a@".wav");

// Close all doors
playAnimSequence($SDoor, 0, false);
playAnimSequence($NDoor1, 0, false);
playAnimSequence($NDoor2, 0, false);
playAnimSequence($WDoor, 0, false);
playAnimSequence($EDoor1, 0, false);
playAnimSequence($EDoor2, 0, false);
// Choose which combo to close
%rand = randomInt(1,8);
if(%rand == 1)
 {
 playAnimSequence($SDoor, 0, true);
 playAnimSequence($NDoor1, 0, true);
 playAnimSequence($NDoor2, 0, true);
 }
if(%rand == 2)
 {
 playAnimSequence($SDoor, 0, true);
 playAnimSequence($WDoor, 0, true);
 }
if(%rand == 3)
 {
 playAnimSequence($SDoor, 0, true);
 playAnimSequence($EDoor1, 0, true);
 playAnimSequence($EDoor2, 0, true);
 }
if(%rand == 4)
 {
 playAnimSequence($NDoor1, 0, true);
 playAnimSequence($NDoor2, 0, true);
 playAnimSequence($WDoor, 0, true);
 }
if(%rand == 5)
 {
 playAnimSequence($NDoor1, 0, true);
 playAnimSequence($NDoor2, 0, true);
 playAnimSequence($EDoor1, 0, true);
 playAnimSequence($EDoor2, 0, true);
 }
if(%rand == 6)
 {
 playAnimSequence($WDoor, 0, true);
 playAnimSequence($EDoor1, 0, true);
 playAnimSequence($EDoor2, 0, true);
 }
if($openDoors == "yes" || %rand == 7)
 {
 playAnimSequence($SDoor, 0, true);
 playAnimSequence($NDoor1, 0, true);
 playAnimSequence($NDoor2, 0, true);
 playAnimSequence($WDoor, 0, true);
 playAnimSequence($EDoor1, 0, true);
 playAnimSequence($EDoor2, 0, true);
 }
if($openDoors == "no" || %rand == 8)
 {
 playAnimSequence($SDoor, 0, false);
 playAnimSequence($NDoor1, 0, false);
 playAnimSequence($NDoor2, 0, false);
 playAnimSequence($WDoor, 0, false);
 playAnimSequence($EDoor1, 0, false);
 playAnimSequence($EDoor2, 0, false);
 }

%when = randomInt(30, 300);
schedule("SwitchDoors();", %when);
}


function player::onAdd(%player)
{
if($server::teamPlay == true) say(%player, %player, "Welcome To TDM_Conglomerate. Your radar has been deactivated, so beware of ambushes.\nSend Comments to Dull@WolfsRangers.com");
else say(%player, %player, "Welcome To DM_Conglomerate. \nSend Comments to Dull@WolfsRangers.com");
if(strAlign(1, left, getname(%player))=="/")
 {
 say(0,0, getname(%player)@" joined the game with a slash.");
 say(%player,0,"Slash Detector in Place.");
 }
log(%player, "joined the game");
}

// Slash Detectors courtesy of Raven M.I.B.

function player::onremove(%player)
{
if(strAlign(1, left, getname(%player))=="/")
 {
 say(0,0,"<f4>"@getname(%player)@" left the game with a slash.");
 }
log(%player, "left the game");
}


function vehicle::onAdd(%vehicle)
{
if($server::teamPlay == true) setVehicleRadarVisible(%vehicle, false);
%player = playerManager::vehicleIdToPlayerNum(%vehicle);
echo(%player.name@" "@%vehicle@" dropped into the game.");
}

function Basement1::trigger::onEnter(%trigger, %vehicle)
{
%player = playerManager::vehicleIdToPlayerNum(%vehicle);
say(%player, %player, "", "repair_ent.wav");
}

function Basement1::trigger::onContact(%trigger, %vehicle)
{
if(isShutDown(%vehicle) != true)
return;
healObject(%vehicle, 300);
}

function Basement3::trigger::onEnter(%trigger, %vehicle)
{
%player = playerManager::vehicleIdToPlayerNum(%vehicle);
say(%player, %player, "", "reload_ent.wav");
}

function Basement3::trigger::onContact(%trigger, %vehicle)
{
if(isShutDown(%vehicle) != true)
return;
reloadObject(%vehicle, 20);
}

function Basement2::trigger::onEnter(%trigger, %vehicle)
{
%x = randomInt(-84, -45);
%y = randomInt(340, 474);
%z = 292;
setPosition(%vehicle, %x, %y, %z);
}

function Basement4::trigger::onEnter(%trigger, %vehicle)
{
%x = randomInt(10, 19);
%y = randomInt(-14, 46);
%z = 228.1;
setPosition(%vehicle, %x, %y, %z);
}

function toTop::structure::onScan(%pylon, %vehicle)
{
%x = randomInt(-129, -60);
%y = randomInt(194, 224);
%z = 163.1438;
setPosition(%vehicle, %x, %y, %z);
}

function Elev_Up::trigger::onEnter(%this, %vehicle)
{
%x = randomInt(-128, -65);
%y = randomInt(-52, 24);
%z = 164.1;
setPosition(%vehicle, %x, %y, %z);
}

function Elev_Down::trigger::onEnter(%this, %vehicle)
{
%x = randomInt(134, 150);
%y = randomInt(157, 207);
%z = 100.1;
setPosition(%vehicle, %x, %y, %z);
}